#include <unistd.h>
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <sys/stat.h>
#include <time.h>
#include <utime.h>
#include <zlib.h>
#include <ctype.h>

#include <expat.h>

#include "ucdcat.h"


using std::cerr;
using std::endl;


#define	BUF_SIZE	8192
#define	UCDCAT		((uCdCat*)ucdcat)

parsingOKEnum parsingOK= OK;
parserTask task;

char *out, *in;

void month( char *m )
{
	if( strncmp( m, "Maj", 3 )==0 )
	{
	 m[2]= 'y';
	}
	else if( strncmp( m, "Sze", 3 )==0 )
	{
	 m[1]= 'e';
	 m[2]= 'p';
	}
	else if( strncmp( m, "Okt", 3 )==0 )
	{
	 m[1]= 'c';
	}
}

void setupCurrentDirectory( uCdCat *ucdcat )
{
	char str[1024];
	Dir *dir= ucdcat->rootDirectory;

	if( ucdcat->media )
	{
	 sprintf( str, "%s/", ucdcat->media );
	}
	else
	 str[0]= '\0';

	while( dir )
	{
	 strcat( str, dir->name );
	 strcat( str, "/" );
	 dir= dir->next;
	}

	delete ucdcat->currentDirectory;
	ucdcat->currentDirectory= strdup( str );
	ucdcat->dirLen= strlen( str );
}

void startElement( void *ucdcat, const char *name, const char **atts )
{
	if( parsingOK!=OK )
	 return;

	if( strcmp( name, "media" )==0 )
	{
	 int i=0;
	 while( atts[i] )
	 {
	  if( strcmp( atts[i], "name" )==0 )
	  {
	   delete UCDCAT->media;
	   UCDCAT->media=strdup( atts[i+1] );
	   setupCurrentDirectory( UCDCAT );
	  }
	  else if( strcmp( atts[i], "owner" )==0 )
	  {
	   delete UCDCAT->user;
	   UCDCAT->user=strdup( atts[i+1] );
	  }
	  else if( strcmp( atts[i], "number" )==0 )
	  {
	   UCDCAT->mediaNumber= atoi( atts[i+1] );
	  }
	  else if( strcmp( atts[i], "type" )==0 )
	  {
	   delete UCDCAT->mediaType;
	   UCDCAT->mediaType= strdup( atts[i+1] );
	  }

	  atts+=2;
	 }
	 return;
	}

	if( strcmp( name, "directory" )==0 )
	{
	 Dir *dir= UCDCAT->rootDirectory;
	 if( dir==NULL )
	 {
	  UCDCAT->rootDirectory= UCDCAT->directory= dir= new Dir;
	  if( dir==NULL )
	  {
	   cerr << "Out of Memory!" << endl;
	   parsingOK= otherError;
	   return;
	  }
	  memset( dir, 0, sizeof(Dir) );
	 }
	 else
	 {
	  dir= UCDCAT->directory;
	  dir= dir->next= new Dir;
	  if( dir==NULL )
	  {
	   cerr << "Out of Memory!" << endl;
	   parsingOK= otherError;
	   return;
	  }
	  memset( dir, 0, sizeof(Dir) );
	  dir->prev= UCDCAT->directory;
	  UCDCAT->directory= dir;
	 }
	 
	 int i= 0;
	 while( atts[i] )
	 {
	  if( strcmp( atts[i], "name" )==0 )
	  {
	   dir->name= strdup( atts[i+1] );
	  }
	  i+= 2;
	 }
	 setupCurrentDirectory( UCDCAT );

	 return;
	}

	if( strcmp( name, "file" )==0 )
	{
	 int i= 0;
	 char str[4096], time[20];
	 uint size= 0;
	 while( atts[i] )
	 {
	  if( strcmp( atts[i], "name" )==0 )
	  {
	   if( task==copyout )
	   {
	    if( strncmp( out, UCDCAT->currentDirectory, UCDCAT->dirLen )==0 )
	    {
	     if( strcmp( out+UCDCAT->dirLen, atts[i+1] )==0 )
	     {
	      UCDCAT->tmp= fopen( in, "wt" );
	      if( UCDCAT->tmp==NULL )
	      {
	       cerr << "ERROR!" << endl;
	       abort();
	      }
	     }
	    }
	   }
	   strcpy( str, atts[i+1] );
	  }
	  else if( strcmp( atts[i], "size" )==0 )
	  {
	   int mul= 1;

	   if( strstr( atts[i+1], "Kb" ) )
	    mul= 1024;
	   else if( strstr( atts[i+1], "Mb" ) )
	    mul= 1024 * 1024;
	   else if( strstr( atts[i+1], "Gb" ) )
	    mul= 1024 * 1024 * 1024;
	   size= atol( atts[i+1] ) * mul;
	  }
	  else if( strcmp( atts[i], "time" )==0 )
	  {
	   int i1= i+1, p= 4;
	   sprintf( time, "%.3s ", atts[i1] );
	   time[0]= toupper( time[0] );
	   month( time );
	   if( (char)atts[i1][6]!=' ' )
	   {
	    p= 6;
	    sprintf( time+4, "0%.1s ", atts[i1]+4 );
	   }
	   else
	   {
	    p= 7;
	    sprintf( time+4, "%.2s ", atts[i1]+4 );
	   }
	   sprintf( time+7, "%.4s ", atts[i1]+strlen( atts[i1] )-4 );
	   if( (char)atts[i1][p+2]==':' )
	   {
	    sprintf( time+12, "%.2s:", atts[i1]+p );
	    p+= 3;
	   }
	   else
	   {
	    sprintf( time+12, "0%.1s:", atts[i1]+p );
	    p+= 2;
	   }
	   if( (char)atts[i1][p+2]==' ' )
	   {
	    sprintf( time+15, "%.2s", atts[i1]+p );
	   }
	   else
	   {
	    sprintf( time+15, "0%.1s", atts[i1]+p );
	   }
	  }
	  i+=2;
	 }
	 if( UCDCAT->tmp )
	 {
	  if( UCDCAT->media )
	  {
	   fprintf( UCDCAT->tmp, "Media:\t\t%s (%u)\n", UCDCAT->media, UCDCAT->mediaNumber );
	   if( UCDCAT->mediaType )
	    fprintf( UCDCAT->tmp, "MediaType:\t%s\n", UCDCAT->mediaType );
	   if( UCDCAT->user )
	    fprintf( UCDCAT->tmp, "Owner:\t\t%s\n", UCDCAT->user );
	   fprintf( UCDCAT->tmp, "\n");
	  }
	  fprintf( UCDCAT->tmp, "Name:\t\t%s%s\n", UCDCAT->currentDirectory ? UCDCAT->currentDirectory : "", str );
	  fprintf( UCDCAT->tmp, "Size:\t\t%u\n", size );
	 }
	 else if( task==list )
	  printf( "-r--r--r-- 1 0 0 %u %s %s%s\n", size, time, UCDCAT->currentDirectory ? UCDCAT->currentDirectory : "", str );

	 return;
	}

	if( task==copyout && UCDCAT->tmp && strcmp( name, "comment" )==0 )
	{
	 UCDCAT->charData= comment;
	}

	if( task==copyout && UCDCAT->tmp && strcmp( name, "mp3tag" )==0 )
	{
	 int i= 0;
	 UCDCAT->charData= mp3Comment;
	 fprintf( UCDCAT->tmp, "\n\nMp3 Tag:\n" );
	 while( atts[i] )
	 {
	  if( strcmp( atts[i], "artist" )==0 )
	  {
	   fprintf( UCDCAT->tmp, " Artist:\t%s\n", atts[i+1] );
	  }
	  else if( strcmp( atts[i], "title" )==0 )
	  {
	   fprintf( UCDCAT->tmp, " Title:\t\t%s\n", atts[i+1] );
	  }
	  else if( strcmp( atts[i], "album" )==0 )
	  {
	   fprintf( UCDCAT->tmp, " Album:\t\t%s\n", atts[i+1] );
	  }
	  else if( strcmp( atts[i], "year" )==0 )
	  {
	   fprintf( UCDCAT->tmp, " Year:\t\t%s\n", atts[i+1] );
	  }
	  i+= 2;
	 }

	 return;
	}

}

void charData( void *ucdcat, const char *data, int len )
{
	if( task==copyout && UCDCAT->tmp && len && UCDCAT->charData!=no )
	{
	 fprintf( UCDCAT->tmp, "%sComment:\t", UCDCAT->charData==comment ? "" : " " );
	 fwrite( data, 1, len, UCDCAT->tmp );
	 fprintf( UCDCAT->tmp, "\n");
	 UCDCAT->charData= no;
	}
}

void endElement( void *ucdcat, const char *name )
{
	if( parsingOK!=OK )
	 return;

	if( strcmp( name, "directory" )==0 )
	{
	 Dir *dir= UCDCAT->directory;

	 if( dir==NULL )
	 {
	  cerr << "Closing <directory> tag without opening one!" << endl;
	  abort();
	 }

	 dir= dir->prev;
	 if( dir==NULL )
	 {
	  delete UCDCAT->directory->name;
	  delete UCDCAT->directory;
	  UCDCAT->rootDirectory= UCDCAT->directory= NULL;
	  delete UCDCAT->currentDirectory;
	  if( UCDCAT->media )
	  {
	   char str[strlen(UCDCAT->media)+3];
	   sprintf( str, "%s/", UCDCAT->media );
	   UCDCAT->currentDirectory= strdup( str );
	   UCDCAT->dirLen= strlen( str );
	  }
	  else
	  {
	   UCDCAT->currentDirectory= NULL;
	   UCDCAT->dirLen= 0;
	  }
	 }
	 else
	 {
	  delete UCDCAT->directory->name;
	  delete UCDCAT->directory;
	  UCDCAT->directory= dir;
	  dir->next= NULL;
	  setupCurrentDirectory( UCDCAT );
	 }

	}
	else if( task==copyout && UCDCAT->tmp && strcmp( name, "file" )==0 )
	{
	 fprintf( UCDCAT->tmp, "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" );
	 fclose( UCDCAT->tmp );
	 exit( 0 );
	}
}

int parseXML( uCdCat *ucdcat, char *file )
{
	gzFile XMLz= gzopen( file, "rb" );
	if( XMLz==NULL )
	{
	 cerr << "Local XML not Found!" << endl;
	 return(-1);
	}

	ucdcat->XML= (gzFile)XMLz;
	XML_Parser parser=XML_ParserCreate( NULL );

	XML_SetUserData( parser, ucdcat );
	XML_SetElementHandler( parser, startElement, endElement );
	XML_SetCharacterDataHandler( parser, charData );
	parsingOK=OK;
	while( true )
	{
	 int bytesRead;
	 char *buffer;
	 if( ( buffer=(char*)XML_GetBuffer( parser, BUF_SIZE ) )==NULL )
	 {
	  cerr << "Out of Memory!" << endl;
	  ucdcat->XML=NULL;
	  gzclose( XMLz );
	  XML_ParserFree( parser );
	  return(-2);
	 }

	 if( ( bytesRead= gzread( XMLz, buffer, BUF_SIZE ) )==-1 )
	 {
	  cerr << "gzread: " << strerror( errno ) << endl;
	  abort();
	 }
	 if( XML_ParseBuffer( parser, bytesRead, bytesRead==0 )==0 )
	 {
	  cerr << "gzread: " << bytesRead << endl;
	  cerr << buffer << endl;
	  cerr << XML_ErrorString( XML_GetErrorCode( parser ) );
	  abort();
	 }
	 if( parsingOK==parseError )
	 {
	  cerr << "Error in XML file parsing" << endl;
	 }
	 else if( parsingOK==otherError )
	 {
	  XML_ParserFree( parser );
	  ucdcat->XML=NULL;
	  gzclose( XMLz );
	  return(-1);
	 }

	 if( bytesRead<=0 )
	  break;

	}

	XML_ParserFree( parser );
	gzclose( XMLz );

	return(0);
}

int main( int argc, char *argv[] )
{
	uCdCat ucdcat;
	memset( &ucdcat, 0, sizeof(ucdcat) );

	if( argc<3 )
	{
	 return(1);
	}

	if( strcmp( argv[1], "list" )==0 )
	 task= list;
	else if( argc==5 && strcmp( argv[1], "copyout" )==0 )
	{
	 task= copyout;
	 out= argv[3];
	 in= argv[4];
	}
	else
	 abort();

	if( parseXML( &ucdcat, argv[2] ) )
	{
	 return(1);
	}

	return(0);

}
